create table `astboard`.`widgets` (
  `widget_id` int unsigned not null auto_increment,
  `widget` varchar(255) not null,
  `pos_x` int unsigned not null default 0,
  `pos_y` int unsigned not null default 0,
  `width` int unsigned not null default 2,
  `height` int unsigned not null default 2,
  `min_width` int unsigned null default null,
  `min_height` int unsigned null default null,
  primary key(`widget_id`)
)engine=InnoDB character set utf8;

create table `astboard`.`widget_items_actions` (
  `action_id` int unsigned not null auto_increment,
  `widget_id` int unsigned not null,
  `action` varchar(255) not null,
  `status` varchar(255) not null,
  primary key(`action_id`),
  foreign key (`widget_id`) references `astboard`.`widgets` (`widget_id`)
)engine=InnoDB character set utf8;

insert into `astboard`.`widgets` values
  (1, 'extensions', 0, 0, 8, 12, 8, 4),
  (2, 'queues', 8, 0, 4, 4, 4, 4),
  (3, 'conferences', 8, 4, 4, 4, 4, 4),
  (4, 'parking', 8, 8, 4, 4, 4, 4);

insert into `astboard`.`widget_items_actions` values
  (1,1,'originate_call','idle'),
  (2,1,'spy','on_call'),
  (3,1,'spy_whisper','on_call'),
  (4,1,'hangup','on_call'),
  (5,2,'queue_login_logout','any'),
  (6,2,'queue_pause_unpause','logged_in'),
  (7,3,'conf_kick','on_conference'),
  (8,4,'unpark','parked');