create table `astboard`.`layouts`(
  `layout_id` int unsigned not null auto_increment,
  `name` varchar(255) not null,
  `visible_by` longtext not null,
  `default` enum('yes', 'no') not null default 'no',
  primary key(`layout_id`)
) engine=InnoDB character set utf8;

create table `astboard`.`layout_widgets` (
  `layout_id` int unsigned not null,
  `widget_id` int unsigned not null,
  `title` varchar(255) null default null,
  `pos_x` int unsigned null default null,
  `pos_y` int unsigned null default null,
  `width` int unsigned null default null,
  `height` int unsigned null default null,
  `items` longtext null default null,
  foreign key (`layout_id`) references `astboard`.`layouts` (`layout_id`) on delete cascade,
  foreign key (`widget_id`) references `astboard`.`widgets` (`widget_id`) on delete cascade
) engine=InnoDB character set utf8;

insert into `astboard`.`layouts` values
  (1,'layout.default','*','yes');

insert into `astboard`.`layout_widgets` values
  (1,1,null,null,null,null,null,'*'),
  (1,2,null,null,null,null,null, '*'),
  (1,3,null,null,null,null,null, '*'),
  (1,4,null,null,null,null,null, '*');
