insert into `astboard`.`module_controllers` (`module_id`, `controller`)
  select
    `module_id`,
    'layouts'
  from `astboard`.`modules`
  where `module` = 'switchboard';

set @controller_id = last_insert_id();

insert into `astboard`.`controller_actions` (`controller_id`, `action`) values
  (@controller_id, 'index'),
  (@controller_id, 'save'),
  (@controller_id, 'remove');

set @cnt = 2;
insert into `astboard`.`menu` (`action_id`, `label`, `parent`, `icon`, `has_sub`, `sort`)
  select
    `a`.`action_id`,
    concat('menu','.',`c`.`controller`) as `label`,
    `m`.`menu_id`,
    null,
    'no',
    (@cnt := @cnt - 1) as `sort`
  from `astboard`.`controller_actions` as `a`
  left join `astboard`.`module_controllers` as `c` on (`a`.controller_id = `c`.`controller_id`)
  left join `astboard`.`menu` as `m` on (`m`.label = 'menu.switchboard')
  where `m`.`parent` = 0 and `c`.`controller` in ('switchboard', 'layouts') and `a`.`action` = 'index';


update `astboard`.`menu` set `has_sub` = 'yes', `action_id` = null where `label` = 'menu.switchboard' and `parent` = 0;

insert into `astboard`.`role_permissions` (`role_id`, `action_id`)
  select
    1,
    `action_id`
  from `astboard`.`controller_actions`
  where `controller_id` = (
    select
      `controller_id`
    from `astboard`.`module_controllers`
    where `controller` = 'layouts'
    limit 1
  );



