create table `astboard`.`widget_settings` (
  `widget_id` int unsigned not null,
  `param` varchar(255) not null,
  `value` longtext null default null,
  foreign key (`widget_id`) references `astboard`.`widgets` (`widget_id`) on delete cascade
) engine=InnoDB character set utf8;

select `widget_id` into @queues_widget_id from `astboard`.`widgets` where `widget` = 'queues';
select `widget_id` into @extensions_widget_id from `astboard`.`widgets` where `widget` = 'extensions';

insert into `astboard`.`widget_settings` (`widget_id`, `param`, `value`) values
  (@queues_widget_id, 'queues_pause_reasons', 'Lunch,Meeting,Bathroom,Away'),
  (@extensions_widget_id, 'extensions_lines', '2');

insert into `astboard`.`module_controllers` (`module_id`, `controller`)
  select
    `module_id`,
    'widgets_settings'
  from `astboard`.`modules`
  where `module` = 'switchboard';


set @controller_id = last_insert_id();

insert into `astboard`.`controller_actions` (`controller_id`, `action`) values
  (@controller_id, 'index'),
  (@controller_id, 'save');

insert into `astboard`.`menu` (`action_id`, `label`, `parent`, `icon`, `has_sub`, `sort`)
  select
    `ca`.`action_id`,
    'menu.widgets_settings',
    `m`.`menu_id`,
    null,
    'no',
    2
  from `astboard`.`controller_actions` as `ca`
  left join `astboard`.`menu` as `m` on (`label` = 'menu.switchboard' and `parent` = 0)
  where `controller_id` = @controller_id and `action` = 'index';


insert into `astboard`.`role_permissions` (`role_id`, `action_id`)
  select
    `r`.`role_id`,
    `ca`.`action_id`
  from `astboard`.`roles` as `r`
  left join `astboard`.`controller_actions` as `ca` on (`controller_id` = @controller_id)
  where `name` not in('Guest');


