alter table `astboard`.`layout_widgets`
  add column `layout_widget_id` int unsigned primary key not null auto_increment first;

alter table `astboard`.`widget_settings`
  add column `widget_setting_id` int unsigned primary key not null auto_increment first,
  add column `is_global` enum('yes','no') not null default 'yes' after `value`;

create table `astboard`.`widget_layout_settings` (
  `layout_widget_id` int unsigned not null,
  `widget_setting_id` int unsigned not null,
  `value` varchar(255) not null,
  foreign key (`layout_widget_id`) references `astboard`.`layout_widgets` (`layout_widget_id`) on delete cascade,
  foreign key (`widget_setting_id`) references `astboard`.`widget_settings` (`widget_setting_id`) on delete cascade
) engine=InnoDB character set utf8;

insert into `astboard`.`widget_settings` (`widget_id`, `param`, `value`, `is_global`)
  select
    `widget_id`,
    'console_mode',
    null,
    'no'
  from `astboard`.`widgets`
  where `widget` = 'extensions';

update `astboard`.`widget_settings` set
  `is_global` = 'no',
  `value` = null
  where `param` = 'hide_unregister_extensions';

update `astboard`.`widget_settings` set
  `is_global` = 'no',
  `value` = null
  where `param` = 'queues_calls_counter_columns';