use `astboard`;

alter table `users`
  add column `tenant` int unsigned null default null,
  add column `super_admin` enum('yes', 'no') not null default 'no';

insert into `controller_actions` (`controller_id`, `action`)
select
  `controller_id`,
  'get_tenant_extensions'
from `module_controllers`
where `controller` = 'users';

set @action_id = last_insert_id();

insert into `role_permissions` (`role_id`, `action_id`)
select
   `role_id`,
   @action_id
from `roles` where `name` != 'Guest';

update `users` set `super_admin` = 'yes' where `user` = 'admin';

insert into `roles` (
                     `name`,
                     `allowed_extensions`,
                     `allowed_queues`,
                     `allowed_parking_lots`,
                     `allowed_conferences`,
                     `extensions_actions`,
                     `queues_actions`,
                     `parking_lots_actions`,
                     `conferences_actions`,
                     `queued_calls_actions`,
                     `allowed_trunks`,
                     `trunks_actions`,
                     `share_layouts`,
                     `update_profile`,
                     `get_updates`,
                     `default_layout`,
                     `allow_layouts_creation`,
                     `default`
                     ) values
                    (
                     'Tenant Administrator', '*', '*', '*', '*', '*', '*', '*', '*',  '*', '*', '*', 'yes', 'yes', 'no',
                     'yes', 'yes', 'yes'
                     );

set @role_id = last_insert_id();

insert into `role_permissions` (`role_id`, `action_id`)
  select
    @role_id,
    `ca`.`action_id`
  from `controller_actions` as `ca`
  left join `module_controllers` as mc on (`mc`.`controller_id` = `ca`.controller_id)
  where `mc`.`controller` in ('core','users', 'roles', 'switchboard','layouts', 'profile');


alter table `roles`
  add column `tenant` int unsigned null default null;

update `users` set `tenant` = 1 where `tenant` is null;
update `roles` set `tenant` = 1 where `tenant` is null;