(function() {
	function getSafety(){
		let CallerName = arguments.callee.caller ? arguments.callee.caller.name : "anonymous";

		if(CallerName === "anonymous" || CallerName !== 'tws')
			return ;

		return new Promise(function (resolve, reject) {
			$.ajax({
				dataType: 'json',
				type: "POST",
				timeout: 60000,
				url: window.location.pathname,
				data: {coreMethod: 'getSafety'},
				success: function (data) {
					resolve(data.token);
				},
				error: reject
			});
		});
	}

	function talkWithServer(action, payload){
		let CallerName = arguments.callee.caller ? arguments.callee.caller.name : "anonymous";
		if(CallerName === "anonymous")
			return ;

		if(CallerName.length){
			let functionRef = window[CallerName];

			if(isConsoleCreated(functionRef)){
				console.error('Execution of this function from browser console is forbidden');
				return ;
			}
		}

		try{
			getSafety().then((flag) => {
				payload.key = flag;

				/*let payloadString = JSON.stringify(payload);
        console.log(`Sending action ${action} with the payload ${payloadString}`)*/

				socket_io.emit(action, payload);

			})
		}catch (e) {
			console.error("Cannot execute the requested action because of the error below!")
			console.log(e)
		}
	}

	function isConsoleCreated(fn) {
		//Let's consider undefined functions as not console created!
		if(fn === undefined)
			return false;

		// Step 1: Convert the function to a string to get its source location
		const fnString = fn.toString();

		// Step 2: Create a dummy error to get the stack trace
		const error = new Error();

		// Step 3: Capture and analyze the stack trace
		const stack = error.stack.toString();


		// Step 4: Check for console-specific markers in the stack trace
		// Return if it was created in the console based on the stack trace
		return fnString.includes('function') && (stack.includes('VM') || stack.includes('<anonymous>') || stack.includes('console'));
	}

	// Expose the function only if necessary, without allowing redefinition
	window.sw = Object.freeze({
		tws: talkWithServer
	});
})();

function hangup(channel) {
	sw.tws('hangup', {
		'channel': channel
	});
}

function pickup(channel, extension, context) {
	sw.tws('pickup_call', {
		'extension': extension,
		'context': context,
		'channel': channel
	})
}


