var kicked_channels = {};

$(function () {
	addModuleCallBack('conferences_widget', function () {
		var conferences_widget = $(".widget-conferences");
		socket_io.on('conference_member', function (data) {
			conf_member_enter(data, conferences_widget);
		});

		socket_io.on('conf_member_leave', function (data) {
			conf_member_leave(data, conferences_widget);
		});

		socket_io.on('conference_member_muted', function (data) {
			conf_member_mute_unmute(data, true);
		});

		socket_io.on('conference_member_unmuted', function (data) {
			conf_member_mute_unmute(data, false);
		});
	});

	addModuleCallBack('conferences_widget_settings', function () {
		launchModuleCallBack('layouts_build_widget');
		dynamic_conferences_layout();
	});
});

function conf_member_enter(data, widget) {
	var collapse_list = widget.find('a[href="#collapse-list-group'+ data.conference +'"]');
	var badge = collapse_list.find('span.badge');
	var ul = widget.find('#wc-' + data.conference);
	var li_member = ul.find('#conf-member-' + data.number);
	if(!li_member.length && typeof kicked_channels[data.channel] === 'undefined'){
		var li = $('<li>');
		var icon = $('<span>');
		var description = $('<span>');
		li.addClass('list-group-item');
		if(data.admin === true)
			li.addClass('conf-admin');
		li.attr('id','conf-member-' + data.number);
		li.attr('data-type','list');
		li.attr('data-channel',data.channel);
		li.attr('data-widget',ul.attr('data-widget'));
		li.attr('data-conf',data.conference);
		li.attr('data-muted',data.muted);
		icon.addClass('fa fa-fw ' + (data.muted ? 'fa-microphone-slash' : 'fa-microphone'));
		description.addClass('description f-size-12');
		description.text(data.number + " - " + data.name);

		icon.appendTo(li);
		description.appendTo(li);
		li.appendTo(ul);

		conferences_context_menu(data.number);
	}else{
		var i = li_member.find('span.fa');
		i.removeClass('fa-microphone-slash');
		i.removeClass('fa-microphone');
		i.addClass((data.muted ? 'fa-microphone-slash' : 'fa-microphone'));
		li_member.attr('data-muted',data.muted);
	}

	if(!badge.length && typeof kicked_channels[data.channel] === 'undefined'){
		var b_span = $("<span>");
		b_span.addClass('badge badge-success pull-right');
		b_span.text('1');
		b_span.appendTo(collapse_list);
	}else{
		badge.text(ul.find('li.list-group-item').size());
	}
}

function conf_member_leave(data, widget) {
	var collapse_list = widget.find('a[href="#collapse-list-group'+ data.conference +'"]');
	var badge = collapse_list.find('span.badge');
	var ul = widget.find('#wc-' + data.conference);
	var li_member = ul.find('li[data-channel="'+ data.channel +'"]');
	if(li_member.length){
		li_member.contextMenu(false);
		li_member.remove();
		kicked_channels[data.channel] = true;
	}

	var members = ul.find('li.list-group-item').size();
	if(members > 0){
		badge.text(ul.find('li.list-group-item').size());
	}else{
		badge.remove();
	}
}

function conf_member_mute_unmute(data, status) {
	var conferences_widget = $(".widget-conferences");
	var ul = conferences_widget.find('#wc-' + data.conference);
	var li_member = ul.find('#conf-member-' + data.number);
	if(li_member.length){
		var i = li_member.find('span.fa');
		i.removeClass('fa-microphone-slash');
		i.removeClass('fa-microphone');
		i.addClass((status ? 'fa-microphone-slash' : 'fa-microphone'));
		li_member.attr('data-muted',status);
	}
}

function conferences_context_menu(number) {
	$.contextMenu({
		selector: '#switchboard-monitor .widget-conferences #conf-member-' + number,
		trigger: getContextualMenuTrigger(),
		build: function(trigger, event) {
			var options = {
				callback: function(key, options) {
					var kick_match = key.match(/^conf_kick-(.*)-(.*)/);
					if(kick_match){
						socket_io.emit('conf_kick',{
							'conference': kick_match[2],
							'channel': kick_match[1]
						});
					}

					var mute_match = key.match(/^(conf_mute|conf_unmute)-(.*)-(.*)/);
					if(mute_match){
						socket_io.emit('conf_mute',{
							'mute': (mute_match[1] === 'conf_mute'),
							'conference': mute_match[3],
							'channel': mute_match[2]
						});
					}
				},
				delay: 500,
				autoHide: true,
				items: {}
			};
			$.ajax({
				type: "POST",
				dataType: "JSON",
				url: window.location.pathname, //Only made request to the actual location
				async: false,
				context: $(this),
				data: {
					action: $('div#switchboard-monitor').find('input[name="wm_action"]').val(),
					widget : trigger.attr('data-widget'),
					conference : trigger.attr('data-conf'),
					channel : trigger.attr('data-channel'),
					muted : trigger.attr('data-muted'),
					status : 'on_conference'
				},
				success: function(response){
					options.items = response;
				},
				error: process_server_error
			});

			return options;
		}
	});
}

function dynamic_conferences_layout() {
	var form = $("#m-form-l-widget-conferences");
	var multiple_dropdown = form.find("select#items");
	multiple_dropdown.multiselect({'sortable': 'both', 'locale': js_data.user_lang});
}

function cleanConferences(){
	var widget = $(".widget-conferences");
	var badge = widget.find('span.badge');
	badge.remove();
	var li_member = widget.find('li');
	li_member.remove();
}