var extensions_widget;
var my_extension_widget;
var extensions_devices_status;

$(function () {
  addModuleCallBack('extensions_widget', function () {
		setupExtensionsVariables();

	  socket_io.on('end_call', function (data) {
		  end_call(data);
	  });

	  socket_io.on('device_state', function (data) {
		  dnd_state(data);
	  });

	  socket_io.on('call_in_process', function (data) {
			if(isValidCall(data))
		  	call_in_progress(data);
	  });

	  socket_io.on('established_call', function (data) {
			if(isValidCall(data))
		  	established_call(data);
	  });

	  socket_io.on('sendmessagestatus', function (data) {
		  send_message_status(data);
	  });

	  socket_io.on('extension_status', function (data) {
	  	  var peer = data.peer;
		  if(typeof devices[peer] !== 'undefined'){
			  var extension = devices[peer];

			  if(extension.length){ //Check if the device has an extension assigned
				  extensions_devices_status[extension][peer] = data.status;
				  var obj = JSON.parse(JSON.stringify(extensions_devices_status[extension]));
				  var array = $.map(obj, function (value, key) {
					  return value;
				  });

				  var registered = (
					  ($.inArray('ok', array) !== -1 || $.inArray('registered', array) !== -1)
					  || $.inArray('reachable', array) !== -1
				  );

				  var element = extensions_widget.find("div.extension-" + extension);
				  if(element.length){
					  element.removeClass('extension-registered');
					  element.removeClass('extension-unregistered');
					  if(registered){
						  element.removeClass('hidden');
						  element.addClass('extension-registered');
						  if(element.attr('data-status') === 'unregistered'){
							  element.attr('data-status','idle');
						  }

					  }else{
						  element.addClass('extension-unregistered');
						  element.attr('data-status','unregistered');

					  }
				  }

				  // Notify other widgets
				  if(registered){
					  ExtensionSummaryUpdatePhoneStatus(extension, true);
				  }else{
					  ExtensionSummaryUpdatePhoneStatus(extension, false);
				  }
			  }
		  }
	  });

	  hot_desking();
	  extensions_search();
	  extensions_context_menu();
	  agents_context_menu();
	  callHold();
		unParkedCall()
  });

	function isValidCall(data){
		if(
				(data.connectedlinenum !== '<unknown>' || data.connectedlinename !== '<unknown>') &&
				(data.connectedlinenum?.length || data.connectedlinename?.length)
		){
			return true;
		}

		// Clean invalid calls
		end_call({
			channel: data.channel
		})

		return false;
	}

	function unParkedCall(){
		socket_io.on('parked_call_retrieved', function (data){
			let call_log = extensions_widget.find('.call-log');
			let call_item = call_log.find('.call-item[data-channel="' + data.channel + '"]');
			if(call_item.length){
				call_item.find('span.description')?.text(
						truncate_string(
								data.connectedlinenum + ' - ' + data.connectedlinename,
								20
						)
				);
			}
		});
	}

  function callHold(){
	  socket_io.on('hold', function (data) {
		  var call_log = extensions_widget.find('.call-log');
		  var call_item = call_log.find('.call-item[data-channel="' + data.channel + '"]');
		  if(call_item.length){
			  call_item.addClass('hold');
			  var parent = call_item.closest("p.call-log");
				let icon = call_item.children("div.ext-data").children("span.icon");

				if(icon.length){
					icon.removeClass('fa-phone-volume');
					icon.addClass('fa-volume-slash');
				}

			  call_item.appendTo(parent);
		  }

	  });

	  socket_io.on('unhold', function (data) {
		  var call_log = extensions_widget.find('.call-log');
		  var call_item = call_log.find('.call-item[data-channel="' + data.channel + '"]');
		  if(call_item.length)
			  call_item.removeClass('hold');
				let icon = call_item.children("div.ext-data").children("span.icon");

				if(icon.length){
					icon.removeClass('fa-volume-slash');
					icon.addClass('fa-phone-volume');
				}
	  });
  }

  addModuleCallBack('extensions_widget_settings', function () {
	  launchModuleCallBack('layouts_build_widget');
	  dynamic_extensions_layout();
  });

  addModuleCallBack('extensions_transfer_modal', function () {
	  var numberField = $("#transfer-ext");
	  numberField.easyAutocomplete({
		  data : js_data.extensions_auto_complete,
		  getValue: 'description',
		  list: {
			  match: {
				  enabled: true
			  },
			  onSelectItemEvent: function() {
				  var value =  numberField.getSelectedItemData().extension;
				  numberField.val(value).trigger("change");
			  },
			  onKeyEnterEvent: function () {
				  var value = numberField.getSelectedItemData().extension;
				  numberField.val(value).trigger("change");
			  }
		  },
		  theme: "square",
		  adjustWidth: false
	  });
  });
});

function setupExtensionsVariables() {
	extensions_widget = $("div.widget-extensions");
	my_extension_widget = $("div.widget-my_extension");
	extensions_devices_status = js_data.extensions_devices_status;
}

function call_in_progress(data) {
  var extension = data.extension;
  if(typeof devices[extension] !== 'undefined'){
    extension = devices[extension];
  }

  if(typeof devices[data.connectedlinenum] !== 'undefined'){
	  data.connectedlinenum = devices[data.connectedlinenum];
  }

  extension = sanitize_number(extension);
  var element = extensions_widget.find('.extension-' + extension);
  var call_log = element.find('.call-log');
  var call_item = call_log.find('.call-item[data-channel="' + data.channel + '"]');
  add_call_item(call_item,call_log,data);
  set_call_status(element, data.status);
  my_extension_add_call(false, extension, data);
}

function established_call(data) {
  var extension = data.extension;
  if(typeof devices[extension] !== 'undefined'){
    extension = devices[extension];
  }
  if(typeof devices[data.connectedlinenum] !== 'undefined'){
    data.connectedlinenum = devices[data.connectedlinenum];
  }

  extension = sanitize_number(extension);
  var element = extensions_widget.find('.extension-' + extension);
  var call_log = element.find('.call-log');
  var call_item = element.find('.call-item[data-channel="' + data.channel + '"]');
  add_call_item(call_item,call_log,data);
  set_call_status(element, 'on-call');
  my_extension_add_call(true, extension, data);
}

function end_call(data) {
  var channel = extensions_widget.find('.call-item[data-channel="' + data.channel + '"]');
  var extension = channel.closest('.extension');
  channel.remove();

  var my_extension_channel = my_extension_widget.find('.call-item[data-channel="' + data.channel + '"]');
  var my_extension_label_channel = my_extension_widget.find('.label-call-item[data-channel="' + data.channel + '"]');
	my_extension_channel.remove();
	my_extension_label_channel.remove();

  if(!my_extension_widget.find('.call-item').length) {
		var call_actions = my_extension_widget.find('.call-actions > .action-btn');
		my_extension_widget.find('.no-calls').show();
		call_actions.addClass('hidden');
	}

	sip_iax_end_call(data);
	telephony_end_call(data);
	if(typeof extension !== 'undefined'){
		set_call_status(extension, 'end');
	}
}

function truncate_string(str, length) {
  return str.length > length ? str.substring(0, length - 3) + '...' : str;
}

function agents_context_menu() {
	$.contextMenu({
		selector: '#switchboard-monitor .widget-extensions i.agent',
		trigger: 'left',
		build: function(trigger, event) {
			var parent = trigger.attr("data-parent");
			var ext = $(document).find("div#"+parent);

			var options = {
				callback: function (key, options) {
					extensionContextMenuCallBack(key, options, ext);
				},
				delay: 500,
				autoHide: true,
				items: {}
			};

			var data = {};

			$.ajax({
				type: "POST",
				dataType: "JSON",
				url: window.location.pathname, //Only made request to the actual location
				async: false,
				context: $(this),
				data: {
					action: $('div#switchboard-monitor').find('input[name="wm_action"]').val(),
					widget : ext.attr('data-widget'),
					queues_menu: true,
					status : 'any',
					extension : ext.attr('data-extension'),
					ext_id: ext.attr('data-id'),
					calls: {},
					queues: ext.attr('data-queues'),
					qal: ( ext.hasClass('qal-active') ? 1 : 0),
					qap: ( ext.hasClass('qap-active') ? 1 : 0)
				},
				success: function(response){
					options.items = response;
				},
				error: process_server_error
			});

			return options;
		}
	});
}

function extensions_context_menu(){
	$.contextMenu({
		selector: '#switchboard-monitor .widget-extensions i.menu,#switchboard-monitor .widget-extensions .console-extension',
		trigger: 'left',
		build: function(trigger, event) {
			var ext = trigger;
			var parent = trigger.attr("data-parent");

			if(typeof parent !== "undefined"){
				ext = $(document).find("div#"+parent);
			}

			var options = {
				callback: function (key, options) {
					extensionContextMenuCallBack(key, options, ext);
				},
				delay: 500,
				autoHide: true,
				items: {}
			};

			var data = {};
			var calls = {};
			ext.find('.call-item').each(function () {
				var bridge = $(this).attr('data-bridge');
				if(typeof bridge !== "undefined"){
					var channel =  $(this).attr('data-channel');
					calls[channel] = {
						'bridge': bridge,
						'description': $(this).find('span.description').text(),
						'channelstatus': $(this).attr('data-channel-status')
					}
				}
			});

			$.ajax({
				type: "POST",
				dataType: "JSON",
				url: window.location.pathname, //Only made request to the actual location
				async: false,
				context: $(this),
				data: {
					action: $('div#switchboard-monitor').find('input[name="wm_action"]').val(),
					widget : ext.attr('data-widget'),
					status : ext.attr('data-status'),
					extension : ext.attr('data-extension'),
					ext_id: ext.attr('data-id'),
					calls: calls,
					queues: ext.attr('data-queues'),
					qal: ( ext.hasClass('qal-active') ? 1 : 0),
					qap: ( ext.hasClass('qap-active') ? 1 : 0)
				},
				success: function(response){
					options.items = response;
				},
				error: process_server_error
			});

			return options;
		}
	});
}

function extensionContextMenuCallBack(key, options, trigger){
	if(typeof user_extension !== 'undefined' && (user_extension && user_extension.length)){
		SpyCall(key, options);
		originateCall(key, options);
		extSendMessage(key, options);
		extTransfer(key, options, trigger);
		extPickUp(key, options);
	}else{
		//Don't throw any warning message when the action is allowed by users without extension
		if(($.inArray(key, ['unpause', 'pause', 'login', 'logout']) === -1 && !key.match(/^(hangup)-(.*)$/)) && !key.match(/^(pause)-(.*)$/))
			 toastr.warning('You have not an extension assigned', 'Extensions');
	}

	queuesActions(key, options, trigger);
	extHangup(key, options);
}

function queuesActions(key, options, trigger) {
	var queues = trigger.attr('data-queues');
	var penalties = trigger.attr('data-penalties');
	let QHints = trigger.attr('data-qhints');
	var extension = trigger.attr('data-extension');
	var name =  trigger.attr('data-name');
	var pause_data = {
		'queue': '',
		'context': queues_context,
		'extension': extension,
		'paused': false,
		'reason': ''
	};

	queues = queues.split(',');
	penalties = penalties.split(',');
	QHints = QHints.split(',');

	var pause_match = key.match(/^(pause)-(\d+)$/);
	if(pause_match)
		key = 'pause';

	$.each(queues,  function (index, queue) {
		var penalty = penalties[index];
		let QHint = QHints[index] ?? `QA_${extension}`
		switch (key){
			case 'login':
				socket_io.emit('queueadd', {
					'queue': queue,
					'context': queues_context,
					'hints_context': js_data.tenant_prefix +'extension-hints',
					'hints_extension': QHint,
					'extension': extension,
					'name': name,
					'penalty': penalty
				});
				update_queue_member_hint(extension, queue, 'login', true);
				break;
			case 'logout':
				socket_io.emit('queueremove', {
					'queue': queue,
					'context': queues_context,
					'extension': extension
				});
				update_queue_member_hint(extension, queue, 'pause', false);
				update_queue_member_hint(extension, queue, 'login', false);
				break;
			case 'unpause':
				pause_data['queue'] = queue;
				socket_io.emit('queuepause', pause_data);
				update_queue_member_hint(extension, queue, 'pause', false);
				break;
			case 'pause':
				var li = options.$selected;

				pause_data['queue'] = queue;
				pause_data['reason'] = li.text();
				pause_data['paused'] = true;

				socket_io.emit('queuepause', pause_data);
				update_queue_member_hint(extension, queue, 'pause', true);
				break;
		}
	});

	if(key === 'login' || key === 'logout'){
		update_queue_member_hint(extension, undefined, 'login', (key === 'login'));
		if(key === 'logout')
			update_queue_member_hint(extension, undefined, 'pause', false);
	}else if (key === 'pause' || key === 'unpause'){
		update_queue_member_hint(extension, undefined, 'pause', (key !== 'unpause'));
	}
}

function SpyCall(key, options){
	var spy_match = key.match(/^(spy|spy_whisper|spy_barge)-(.*)$/);
	if(spy_match){
		sw.tws('spy_call', {
			'extension': user_extension,
			'context': user_context,
			'spyto': spy_match[2],
			'whisper': (spy_match[1] === 'spy_whisper'),
			'barge': (spy_match[1] === 'spy_barge')
		})
	}
}

function originateCall(key, options) {
	var call_match = key.match(/^(originate_call)-(.*)$/);
	if(call_match){
		sw.tws('call', {
			'extension': user_extension,
			'context': user_context,
			'callee': call_match[2]
		})
	}
}

function extSendMessage(key, options) {
	var message_match = key.match(/^(send_message)-(.*)$/);
	if(message_match){
		var target_extension = message_match[2];
		var devices = Object.keys(extensions_devices_status[target_extension]);
		var valid_devices = [];
		$.each(devices, function (i, device) {
			var device_split = device.split('/');
			var tech = device_split[0].toLowerCase();
			switch (tech) {
				case 'sip':
				case 'pjsip':
					valid_devices.push(tech + ':' + device_split[1]);
					break;
			}
		});

		if(valid_devices.length) {
			swal({
					title: js_data.send_message_title,
					text: js_data.send_message_to + ' ' + target_extension,
					confirmButtonText: js_data.send_message_btn,
					type: "input",
					showCancelButton: true,
					closeOnConfirm: false,
					animation: "slide-from-top",
					inputPlaceholder: ''
				},
				function(inputValue){
					if (inputValue === false) return false;

					if (inputValue === "") {
						swal.showInputError(js_data.send_message_empty);
						return false
					}

					$.each(valid_devices, function (i, device) {
						sw.tws('sendmessage', {
							'to': device,
							'from': user_extension,
							'body': inputValue
						})
					});

					swal.close();
				});
		} else {
			toastr.warning(js_data.send_message_invalid_devices, 'Sonata | Switchboard')
		}
	}
}

function extTransfer(key, options, trigger) {
	var transfer_match = key.match(/^(axfer|bxfer)-(.*)$/);
	if(transfer_match){
		virtual_submit({
			action: $('div#switchboard-monitor').find('input[name="wf_action"]').val(),
			widget : trigger.attr('data-widget'),
			channel: transfer_match[2],
			transfer_type: transfer_match[1],
			form: 'transfer_call'
		});
	}
}

function extPickUp(key, options) {
	var pickup_match = key.match(/^(pickup_call)-(.*)$/);
	if(pickup_match){
		sw.tws('pickup_call', {
			'extension': user_extension,
			'context': user_context,
			'channel': pickup_match[2]
		})
	}
}

function extHangup(key, options) {
	var hangup_match = key.match(/^(hangup)-(.*)$/);
	if(hangup_match){
		sw.tws('hangup', {
			'channel': hangup_match[2]
		});
	}
}

function add_call_item(call_item,container,data) {
	if(!call_item.length) {
		container.prepend(
			'<div class="call-item" data-channel-status="'+ data.channelstatus +'" data-bridge="'+ data.bridge_peer +'" data-channel=' + data.channel +'>' +
			'<div class="ext-data pull-left">' +
			'<span class="fas fa-phone-volume icon"></span> ' +
			'<span class="description text-nowrap">' + truncate_string(data.connectedlinenum + ' - ' + data.connectedlinename, 20) + '</span>' +
			'</div>' +
			'<div class="call-data pull-right">' +
			'<span class="duration" data-duration="' + data.duration + '">'+ toHHMMSS(data.duration) +'</span>' +
			'</div>' +
			'</div>'
		);

		var extensions_interval = setInterval(function () {
			var elem = container.find('.call-item[data-channel="' + data.channel +'"]');
			if(elem.length){
				var duration_span = elem.find('span.duration');
				var new_duration = parseInt(duration_span.attr('data-duration')) + 1;
				duration_span.attr('data-duration', new_duration);
				duration_span.text(toHHMMSS(new_duration));
			}else{
				clearInterval(extensions_interval);
			}
		}, 1000);
	} else {
		call_item.attr('data-bridge', data.bridge_peer);
		call_item.attr('data-channel-status', data.channelstatus);
		call_item.find('span.description').text(truncate_string(data.connectedlinenum + ' - ' + data.connectedlinename, 20));
		call_item.find('span.duration').attr('data-duration', data.duration);
		call_item.find('span.duration').text(toHHMMSS(data.duration));
	}
}

function my_extension_add_call(established, extension, data) {
	var my_extension = my_extension_widget.find('.my-extension-' + extension);
	if(my_extension.length) {
		var current_calls = my_extension.find('.current-calls');
		var call_item = my_extension.find('.call-item[data-channel="' + data.channel + '"]');
		var call_actions = my_extension.find('.call-actions');

		if(call_item.length && established) {
			call_item.attr('data-linkedid', data.linkedid);
		}
		my_extension.find('.no-calls').hide();
		add_call_item(call_item, current_calls, data);
	}
}

function set_call_status(element,status){
  element.removeClass(function (index, className) {
		return (className.match(/phone-[a-z&-]+/) || []).join(' ');
  });

  var call_log = element.find('.call-log');
  var call_items = call_log.find('.call-item').length;

  if(status !== 'end'){
	  element.addClass('phone-' + status);
	  element.attr('data-status',status);
  }else{
		if(call_items <= 0){
			element.attr('data-status','idle');
		}else{
			element.addClass('phone-' + 'on-call');
			element.attr('data-status','on-call');
		}
  }
}

function send_message_status(data) {
	var status = data.status;
	toastr.options.preventDuplicates = true;
	switch (status) {
		case 'Success':
			toastr.success(data.message, 'Sonata | Switchboard');
			break;

		default:
			toastr.warning(data.message, 'Sonata | Switchboard');
	}
}

function dynamic_extensions_layout() {
	var form = $("#m-form-l-widget-extensions");
	var multiple_dropdown = form.find("select#items");
	multiple_dropdown.multiselect({'sortable': 'both', 'locale': js_data.user_lang});
}

function extensions_transfer_call(modal) {
	var selected_extension = modal.find('#transfer-ext').val();
	var channel = modal.find('input[name="channel"]').val();
	var action =  modal.find('#transfer_type').val();

	var modal_title = modal.find('h4.modal-title').text();
	var warning_message = modal.find('input[name="invalid_data"]').val();
	if(selected_extension.length){
		sw.tws(action, {
			'originator': user_extension,
			'exten': selected_extension,
			'context': user_context,
			'channel': channel
		})
	}else{
		toastr.warning(warning_message, modal_title);
	}

	modal.modal('hide');
}

function dnd_state(data) {
	var element = extensions_widget.find('.board-card.extension[data-dnd="'+ data.device +'"]');
	if(element.length){
		if(data.status === 'NOT_INUSE' || data.status === 'UNAVAILABLE'){
			element.removeClass('dnd-active');
		}else if(data.status === 'BUSY' || data.status === 'INUSE'){
			element.addClass('dnd-active');
		}

		buildExtensionHintInfo(element);
	}

	// DND For other Widgets
	if(data.status === 'NOT_INUSE' || data.status === 'UNAVAILABLE'){
		ExtensionSummaryDND(data.device, false);
	}else if(data.status === 'BUSY' || data.status === 'INUSE'){
		ExtensionSummaryDND(data.device, true);
	}
}

function setQueuesStatus(data) {
	setupExtensionsVariables();
	if(!extensions_widget.length)
		return ;

  $.each(data, function (extension, queues) {
	  var element = extensions_widget.find('.board-card.extension[data-extension="'+ extension +'"]');

	  //Do this if the extension is shown on the GUI, otherwise return
	  if(!element.length)
	  	return ;

	  var obj = JSON.parse(JSON.stringify(queues));
	  //Storage the value of the logged in status
	  var logged_in = $.map(obj, function (data, key) {
		  return data.logged_in;
	  });

	  //Storage the value of the paused status
	  var paused = $.map(obj, function (data, key) {
		  return data.paused;
	  });

	  //Storage the value of the paused reason
	  var paused_reason = $.map(obj, function (data, key) {
		  return data.paused_reason;
	  });

	  var pauseElement = element.find("span.pause-reason");

	  //Set Paused Status
	  if($.inArray('yes', paused) === -1){
		  element.removeClass('qap-active');
		  pauseElement.hide();
	  }else{
		  element.addClass('qap-active');
		  var pause = paused_reason.shift();
		  pauseElement.show();
		  pauseElement.text((pause.length ? pause : pauseElement.attr('data-text')));
	  }

	  //Set logged in status
	  if($.inArray('yes', logged_in) === -1){
		  element.removeClass('qal-active');
		  element.removeClass('qap-active');
		  pauseElement.hide();
	  }else{
		  element.addClass('qal-active');
	  }

	  buildExtensionHintInfo(element);
  })
}

function buildExtensionHintInfo(element) {
	var dnd_active = element.hasClass('dnd-active');
	var qap_active = element.hasClass('qap-active');
	var info_elem = element.find('div.ext-info');
	var icon = info_elem.find('i');

	icon.attr('class', 'fas fa-user');

	if(dnd_active && qap_active){
		icon.attr('class', 'fas fa-user-clock');
	}else if(dnd_active && !qap_active){
		icon.attr('class', 'fas fa-user');
	}else if (!dnd_active && qap_active){
		icon.attr('class', 'fas fa-user-clock');
	}
}


function hot_desking() {
	socket_io.on('hotdesk_added', function (data) {
		var device = data.device;
		var dev_split = device.split('/');
		extensions_devices_status[data.extension] = {};
		extensions_devices_status[data.extension][device] = 'unknown';
		devices[device] = data.extension;
		devices[dev_split[1]] = data.extension;

		socket_io.emit('switchboard_peer_info');
	});

	socket_io.on('hotdesk_removed', function (data) {
		var device = data.device;
		var dev_split = device.split('/');
		extensions_devices_status[data.extension] = {};
		var element = extensions_widget.find("div.extension-" + data.extension);
		element.removeClass('extension-registered');
		element.addClass('extension-unregistered');
		devices[device] = '';
		devices[dev_split[1]] = '';

		//Update the Status in the Extensions Summary Widget
		ExtensionSummaryUpdatePhoneStatus(data.extension, false);
	});
}

function extensions_search() {
	var input = $(".widget-extensions div.search-field > input");
	input.unbind('change keyup focusout');
	input.on('change keyup focusout', function () {
		var search_value = $(this).val();
		var main_parent =  $(this).parents('div.widget-extensions');
		var container = main_parent.find('div.board-card-container');
		var hide_unregistered = container.hasClass('hide-unregister-extensions');
		if(search_value === ''){
			main_parent.find('div.board-card.extension').show();
		} else{
			main_parent.find('div.board-card.extension').hide();
			main_parent.find('div.board-card.extension').each(function () {
				var label = $(this).find('div.media-body > h6');
				var found = (label.text().toUpperCase().indexOf(search_value.toUpperCase()) !== -1);
				if(found){
					if(hide_unregistered && $(this).hasClass('extension-unregistered'))
						return true; //continue;

					$(this).show();
				}
			});
		}

		if(hide_unregistered){
			main_parent.find('div.board-card.extension-unregistered').hide();
		}
	});
}

function callsClean() {
	//Extensions - Clean
	var channel = extensions_widget.find('.call-item');
	var extension = channel.closest('.extension');
	channel.remove();
	extension.each(function () {
		set_call_status($(this), 'end');
	});

	//My Extension - Clean
	var my_extension_channel = my_extension_widget.find('.call-item');
	var my_extension_label_channel = my_extension_widget.find('.label-call-item');
	my_extension_channel.remove();
	my_extension_label_channel.remove();
	var call_actions = my_extension_widget.find('.call-actions > .action-btn');
	my_extension_widget.find('.no-calls').show();
	call_actions.addClass('hidden');

	//Trunks - Clean
	var trunk_call_item = trunk_widget.find('.call-item');
	trunk_call_item.remove();
	var title = trunk_widget.find('.accordion-title');
	title.find('.accordion-label').removeAttr('data-status');
	var badge = trunk_widget.find('span.badge');
	badge.remove();
}
