var my_extension_widget;
var call_actions_btn;

$(function () {
	addModuleCallBack('my_extension_widget', function () {
		setupMyExtensionVariables();
		var dialer = my_extension_widget.find('.phone-dialer');
		var screen = dialer.find('.screen');
		var screen_dialer = dialer.find('.screen-dialer');

		$(document).on('click', '.current-calls > .call-item', function () {
			var calls = $(document).find('.current-calls > .call-item');
			var current_call = $(document).find('.current-calls > .call-item.selected');
			calls.removeClass('selected');
			if(current_call.hasClass('selected'))
				$(this).removeClass('selected');
			else
				$(this).addClass('selected');
			call_actions_btn.removeClass('hidden');
		});

		call_actions_btn.on('click', function () {
			var current_call = $(document).find('.current-calls > .call-item.selected');
			if(current_call.length) {
				var channel = current_call.data('channel');
				if($(this).hasClass('transfer')) {
					virtual_submit({
						action: $('div#switchboard-monitor').find('input[name="wf_action"]').val(),
						widget: $(this).attr('data-widget'),
						channel: channel,
						transfer_type: 'bxfer',
						form: 'transfer_call'
					});
				}else if($(this).hasClass('supervisor')){
					virtual_submit({
						action: $('div#switchboard-monitor').find('input[name="wf_action"]').val(),
						widget: $(this).attr('data-widget'),
						channel: channel,
						form: 'supervisor_call'
					});
				}else if($(this).hasClass('park')) {
					channel = current_call.data('bridge');

					sw.tws('park', {
						'channel': channel
					});

				}else if($(this).hasClass('hangup')) {
					sw.tws('hangup', {
						'channel': channel
					});
				}
			}
		});

		var transfer_btn = my_extension_widget.find('.action-btn.transfer > span');
		dialer.find('.dialer-btn').on('click', function () {
			var btn_val = $(this).text();
			var actual_val = screen_dialer.val();
			screen_dialer.val(actual_val + btn_val);

			var current_call = $(document).find('.current-calls > .call-item.selected');
			if((screen_dialer.val()).length > 0 && current_call.length)
				transfer_btn.removeClass('disabled');
		});

		screen.find('.screen-del-btn').on('click', function () {
			var actual_val = screen_dialer.val();
			screen_dialer.val(actual_val.substring(0, actual_val.length - 1));

			if((screen_dialer.val()).length === 0)
				transfer_btn.addClass('disabled');
		});

		dialer.find('.call-btn').on('click', function () {
			sw.tws('call', {
				'extension': js_data.user_extension,
				'context': js_data.user_context,
				'callee': screen_dialer.val()
			})

			screen_dialer.val('');
		});

		settings_context_menu();
	});

	addModuleCallBack('my_extension_widget_settings',function () {
		launchModuleCallBack('layouts_build_widget');
	});

	addModuleCallBack('request_supervisor_modal', function () { });
});

function setupMyExtensionVariables() {
	my_extension_widget = $("div.widget-my_extension");
	call_actions_btn = my_extension_widget.find('.action-btn');
}

function settings_context_menu() {
	$.contextMenu({
		selector: '#switchboard-monitor .my-extension .screen-menu-btn',
		trigger: getContextualMenuTrigger(),
		build: function(trigger) {
			var options = {
				callback: function(key, opt) {
					var my_queues = trigger.attr('data-my-queues');
					var my_penalties = trigger.attr('data-my-penalties');
					let myQHints = trigger.attr('data-my-qhints');

					my_queues = my_queues.split(',');
					my_penalties = my_penalties.split(',');
					myQHints = myQHints.split(',');

					$.each(my_queues,  function (index, queue) {
						var penalty = my_penalties[index];
						let QHint = myQHints[index] ?? `QA_${user_extension}`;

						switch (key){
							case 'login':
								socket_io.emit('queueadd', {
									'queue': queue,
									'context': queues_context,
									'hints_context': js_data.tenant_prefix +'extension-hints',
									'hints_extension': QHint,
									'extension': user_extension,
									'name': trigger.attr('data-name'),
									'penalty': penalty
								});
								update_queue_member_hint(user_extension, queue, 'login', true);
								break;
							case 'logout':
								socket_io.emit('queueremove', {
									'queue': queue,
									'context': queues_context,
									'extension': user_extension
								});
								update_queue_member_hint(user_extension, queue, 'login', false);
								break;
							case 'unpause':
								update_pause_status(queue, false, '');
								break;
							default:
								var li = opt.$selected;
								update_pause_status(queue, true, li.text());
								break;
						}
					});

					if(key === 'login' || key === 'logout'){
						update_queue_member_hint(user_extension, undefined, 'login', (key === 'login'));
					}else{
						update_queue_member_hint(user_extension, undefined, 'pause', (key !== 'unpause'));
					}
				},
				delay: 500,
				autoHide: true,
				items: {}
			};

			$.ajax({
				type: "POST",
				dataType: "JSON",
				url: window.location.pathname, //Only made request to the actual location
				async: false,
				context: $(this),
				data: {
					action: $('div#switchboard-monitor').find('input[name="wm_action"]').val(),
					widget : trigger.attr('data-widget')
				},
				success: function(response){
					options.items = response;
				},
				error: process_server_error
			});

			return options;
		}

	});
}

function update_pause_status(queue, pause, reason) {
	var data = {
		'queue': queue,
		'context': queues_context,
		'extension': user_extension,
		'paused': pause,
		'reason': reason
	};

	socket_io.emit('queuepause', data);
	update_queue_member_hint(user_extension, queue, 'pause', pause);
}

function call_supervisor(modal) {
	var join_mode = modal.find('#join_mode').val();
	var channel = modal.find('input[name="channel"]').val();
	var supervisor = modal.find('input[name="supervisor"]').val();

	sw.tws('spy_call', {
		'extension': supervisor,
		'context': user_context,
		'spyto': channel,
		'whisper': (join_mode === 'whisper'),
		'barge': (join_mode === 'barge'),
		'cid': '"Agent Request" <'+ user_extension +'>'
	})

	modal.modal('hide');
}