$(function () {
	addModuleCallBack('my_queues_widget', function () {
		my_queues_context_menu();
	});

	addModuleCallBack('my_queues_widget_settings', function () {
		launchModuleCallBack('layouts_build_widget');
	});
});

function my_queues_context_menu() {
	$.contextMenu({
		selector: '#switchboard-monitor .widget-my_queues .my-queues-items',
		trigger: getContextualMenuTrigger(),
		build: function(trigger, event) {
			var options = {
				callback: function(key, opt) {
					switch (key){
						case 'logged_out':
							socket_io.emit('queueremove', {
								'queue': trigger.attr('data-queue'),
								'context': queues_context,
								'extension': user_extension
							});

							update_queue_member_hint(user_extension, trigger.attr('data-queue'), 'login', false);
							break;
						case 'logged_in':
							socket_io.emit('queueadd', {
								'queue': trigger.attr('data-queue'),
								'context': queues_context,
								'hints_context': js_data.tenant_prefix +'extension-hints',
								'extension': user_extension,
								'name': trigger.attr('data-name'),
								'penalty': trigger.attr('data-penalty'),
								'hints_extension': trigger.attr('data-q-hint'),
							});

							update_queue_member_hint(user_extension, trigger.attr('data-queue'), 'login', true);
							break;
						case 'pause':
							member_update_pause_status(trigger, true, '');
							break;
						case 'unpause':
							member_update_pause_status(trigger, false, '');
							break;
						default:
							var li = opt.$selected;
							member_update_pause_status(trigger, true, li.text());
							break;
					}
				},
				delay: 500,
				autoHide: true,
				items: {}
			};

			$.ajax({
				type: "POST",
				dataType: "JSON",
				url: window.location.pathname, //Only made request to the actual location
				async: false,
				context: $(this),
				data: {
					action: $('div#switchboard-monitor').find('input[name="wm_action"]').val(),
					widget : trigger.attr('data-widget'),
					status : trigger.attr('data-status'),
					type : trigger.attr('data-type'),
					paused : trigger.attr('data-paused')
				},
				success: function(response){
					options.items = response;
				},
				error: process_server_error
			});

			return options;
		}
	});
}

function member_update_pause_status(trigger, pause, reason) {
	var data = {
		'queue': trigger.attr('data-queue'),
		'context': queues_context,
		'extension': user_extension,
		'paused': pause,
		'reason': reason
	};

	socket_io.emit('queuepause', data);
	update_queue_member_hint(user_extension, trigger.attr('data-queue'), 'pause', pause);
}