$(function () {
	addModuleCallBack('parking_lots_widget',function () {
		var parking_widget = $(".widget-parking_lots");
		socket_io.on('parked_call', function (data) {
			var collapse_list = parking_widget.find('a[href="#collapse-list-group'+ data.lot +'"]');
			var badge = collapse_list.find('span.badge');
			var ul = parking_widget.find('#wc-' + data.lot);
			if(!ul.find('#space-' + data.space).length){
				var li = $('<li>');
				var icon = $('<span>');
				var description = $('<span>');
				li.addClass('list-group-item');
				li.attr('id','space-' + data.space);
				li.attr('data-type','list');
				li.attr('data-channel',data.channel);
				li.attr('data-space',data.space);
				li.attr('data-widget',ul.attr('data-widget'));
				icon.addClass('fas fa-parking icon');
				description.addClass('description f-size-12');
				description.text(data.space + ', ' + data.parkee_number + '-' + data.parkee_name);

				icon.appendTo(li);
				description.appendTo(li);
				li.appendTo(ul);

				parking_spaces_context_menu(data.space);
			}

			var slots = ul.find('li.list-group-item').size();
			if(!badge.length){
				var b_span = $("<span>");
				b_span.addClass('badge badge-success pull-right');
				b_span.text('1');
				b_span.appendTo(collapse_list);
			}else{
				badge.text(slots);
			}
		});

		socket_io.on('parked_call_hangup', function (data) {
			var space = parking_widget.find('#space-' + data.space);
			if(!space.length)
				return ;

			var collapse_list = parking_widget.find('a[href="#collapse-list-group'+ data.lot +'"]');
			var badge = collapse_list.find('span.badge');
			var ul = parking_widget.find('#wc-' + data.lot);
			if(space.length){
				space.remove();
			}

			if(ul.find('li.list-group-item').size() < 1 ){
				badge.remove();
			}
		});
	});

	addModuleCallBack('parking_lots_widget_settings',function () {
		launchModuleCallBack('layouts_build_widget');
		dynamic_parking_lots_layout();
	});
});

function parking_spaces_context_menu(space){
	$.contextMenu({
		selector: '#switchboard-monitor .widget-parking_lots #space-'+space,
		trigger: getContextualMenuTrigger(),
		build: function(trigger, event) {
			var options = {
				callback: function(key, options) {
					if(typeof user_extension !== 'undefined' && user_extension.length){
						var match = key.match(/^unpark-(.*)/);
						if(match){
							sw.tws('call', {
								'extension': user_extension,
								'context': user_context,
								'callee': match[1]
							})
						}
					}else{
						toastr.warning('You have not an extension assigned', 'Extensions');
					}
				},
				delay: 500,
				autoHide: true,
				items: {}
			};
			$.ajax({
				type: "POST",
				dataType: "JSON",
				url: window.location.pathname, //Only made request to the actual location
				async: false,
				context: $(this),
				data: {
					action: $('div#switchboard-monitor').find('input[name="wm_action"]').val(),
					widget : trigger.attr('data-widget'),
					space : trigger.attr('data-space'),
					status : 'parked'
				},
				success: function(response){
					options.items = response;
				},
				error: process_server_error
			});

			return options;
		}

	});
}

function dynamic_parking_lots_layout() {
	var form = $("#m-form-l-widget-parking_lots");
	var multiple_dropdown = form.find("select#items");
	multiple_dropdown.multiselect({'sortable': 'both', 'locale': js_data.user_lang});
}

function parkingClean() {
	var parking_widget = $(".widget-parking_lots");
	var badge = parking_widget.find('span.badge');
	badge.remove();

	var members = parking_widget.find('li');
	members.remove();
}
