$(function () {
	addModuleCallBack('queue_members_widget',function () {
		queue_members_context_menu();
	});

	addModuleCallBack('queue_members_widget_settings', function () {
		launchModuleCallBack('layouts_build_widget');
	});
});

function queue_members_context_menu(){
	$.contextMenu({
		selector: '#switchboard-monitor .widget-queue_members td.status',
		trigger: getContextualMenuTrigger(),
		build: function (trigger, event) {
			var options = {
				callback: function (key, opt) { queue_members_cm_callback(trigger, key, opt) },
				delay: 500,
				autoHide: true,
				items: {}
			};

			$.ajax({
				type: "POST",
				dataType: "JSON",
				url: window.location.pathname, //Only made request to the actual location
				async: false,
				context: $(this),
				data: {
					action: $('div#switchboard-monitor').find('input[name="wm_action"]').val(),
					widget : trigger.attr('data-widget'),
					status : trigger.attr('data-status'),
					type : trigger.attr('data-type'),
					paused : trigger.attr('data-paused'),
					extension: trigger.attr('data-extension')
				},
				success: function(response){
					options.items = response;
				},
				error: process_server_error
			});

			return options;
		}
	});
}

function queue_members_cm_callback(trigger, key, opt) {
	switch (key){
		case 'logged_out':
			socket_io.emit('queueremove', {
				'queue': trigger.attr('data-queue'),
				'context': trigger.attr('data-context'),
				'extension': trigger.attr('data-extension')
			});

			update_queue_member_hint(trigger.attr('data-extension'), trigger.attr('data-queue'), 'login', false);
			break;
		case 'logged_in':
			socket_io.emit('queueadd', {
				'queue': trigger.attr('data-queue'),
				'context': trigger.attr('data-context'),
				'hints_context': js_data.tenant_prefix +'extension-hints',
				'extension': trigger.attr('data-extension'),
				'name': trigger.attr('data-name'),
				'penalty': trigger.attr('data-penalty'),
				'hints_extension': trigger.attr('data-q-hint'),
			});
			update_queue_member_hint(trigger.attr('data-extension'), trigger.attr('data-queue'), 'login', true);
			break;
		case 'pause':
			queue_member_update_pause_status(trigger, true, '');
			break;
		case 'unpause':
			queue_member_update_pause_status(trigger, false, '');
			break;
		default:
			var li = opt.$selected;
			queue_member_update_pause_status(trigger, true, li.text());
			break;
	}
}

function queue_member_update_pause_status(trigger, pause, reason) {
	var data = {
		'queue': trigger.attr('data-queue'),
		'context': trigger.attr('data-context'),
		'extension': trigger.attr('data-extension'),
		'paused': pause,
		'reason': reason
	};

	socket_io.emit('queuepause', data);
	update_queue_member_hint(trigger.attr('data-extension'), trigger.attr('data-queue'), 'pause', pause);
}