var queues_overview_interval = {};

$(function () {
	addModuleCallBack('queues_stats_summary_widget',function () {
		socket_io.on('queue_params', function (data) {
			queue_stats_data(data);
			my_queues_queued_calls(data);
			update_queue_wallboard_stats(data);
		});

		socket_io.on('queue_times', function (data) {
			queue_stats_data(data);
			update_queue_wallboard_summary(data);
		});
	});

	addModuleCallBack('queues_stats_summary_widget_settings',function () {
		launchModuleCallBack('layouts_build_widget');
		dynamic_qss_layout();
	});
});

function queue_stats_data(data) {
	var queue = data.queue;
	$.each(data, function (i, v) {
		var element = $(".qss-" + queue + "." + i);
		if(element.length){
			if(i === 'strategy'){
				element.text(queues_strategy[v]); //Show a friendly strategy name
			}else{
				element.text(v);
			}
		}

		var qo_element = $("#qo-" + queue + "-" + i + ' .indicator-counter');
		if(i === 'services_level')
				set_progress(queue, parseInt(v));
		if(i === 'longest_hold_time'){
			qo_element.text(toHHMMSS(v));
			if(typeof queues_overview_interval[data.queue] === 'undefined'){
				queues_overview_interval[data.queue] = setInterval(function () {
					var current_seconds = parseInt(toSeconds(qo_element.text()));
					var new_time = current_seconds + 1;
					var current_calls = $("#qo-" + queue + '-queued_calls .indicator-counter');
					current_calls = parseInt(current_calls.text());
					if(current_calls > 0){
						qo_element.text(toHHMMSS(new_time));
					}else{
						clearInterval(queues_overview_interval[data.queue]);
						qo_element.text(toHHMMSS(0));
						queues_overview_interval[data.queue] = undefined;
					}
				}, 1000)
			}

		}else{
			qo_element.text(v);
		}


		var qcc_element = $("#qcc-" + queue + "-" + i);
		if(qcc_element.length) {
			if(i === 'queued_calls') {
				var status = 'default';

				if (v == 1)
					status = 'excellent';
				else if (v > 1 && v <= 4)
					status = 'very_good';
				else if(v > 4 && v <= 7)
					status = 'good';
				else if (v > 7 && v >= 8)
					status = 'regular';

				qcc_element.closest('.counter-item').attr('data-status', status);
				qcc_element.closest('.counter-item').attr('data-calls', v);
				var mainQCCElement = qcc_element.parents('div.queues-calls-counter');
				sortQueuesCallCounter(mainQCCElement);
			}
			qcc_element.text(v);
		}
	});
}

function sortQueuesCallCounter(mainQCCElement){
	var sort_mode = mainQCCElement.attr('data-sort');

	if(sort_mode === 'auto'){
		mainQCCElement.find('div.queue-counter-item').sort(function (a, b) {
			var aci = $(a).children('div.counter-item');
			var bci = $(b).children('div.counter-item');

			return (bci.attr('data-calls')) > (aci.attr('data-calls')) ? 1 : -1;
		}).appendTo(mainQCCElement);
	}
}

function set_progress(queue, value) {
    var progress_value = $('.qo-sla-indicator-' + queue + ' .progress-value');
    var progress_label = $('.qo-sla-indicator-' + queue + ' .sla-indicator-value');

    var RADIUS = 54;
    var CIRCUMFERENCE = 2 * Math.PI * RADIUS;
    progress_value.css('stroke-dasharray', CIRCUMFERENCE);

    var progress = function (value) {
        var progress = value / 100;
        progress_value.css('stroke-dashoffset', CIRCUMFERENCE * (1 - progress));
        progress_label.text(value);

        var level = 'regular';

		if (value <= 70)
            level = 'good';
		else if (value <= 90)
            level = 'very_good';
		else if(value <= 100)
            level = 'excellent';

        progress_value.attr('data-level', level);
    };

    progress(parseInt(value));
}

function dynamic_qss_layout() {
	var form = $("#m-form-l-widget-queues_stats_summary");
	var multiple_dropdown = form.find("select#items");
	multiple_dropdown.multiselect({'sortable': 'both', 'locale': js_data.user_lang});
}

function my_queues_queued_calls(data) {
	var widget = $(".widget-my_queues");
	var queued_calls = widget.find('.' + data.queue + '-queued_calls');
	queued_calls.html(data.queued_calls);
}