var queue_wallboard_intervals = {};

$(function () {
	addModuleCallBack('queues_wallboard_widget_settings', function () {
		launchModuleCallBack('layouts_build_widget');
	});
});

function update_queue_wallboard_stats(data) {
	var wallboard = $("#switchboard-content").find('.q-wallboard-'+data.queue);
	if(!wallboard.length)
		return ;

	wallboard.find('div.completed_calls > div.panel-container').children('span.panel-data').html(data.completed_calls);
	wallboard.find('div.abandoned_calls > div.panel-container').children('span.panel-data').html(data.abandoned_calls);
	wallboard.find('div.sla > div.panel-container').children('span.panel-data').html(Math.round(data.services_level)+'%');
	wallboard.find('div.longest_hold > div.panel-container').attr('sla_target', parseInt(data.sla_target));
	wallboard.find('div.waiting_callers > div.panel-container').children('span.panel-data').html(data.queued_calls);

}

function update_queue_wallboard_summary(data) {
	var wallboard = $("#switchboard-content").find('.q-wallboard-'+data.queue);
	if(!wallboard.length)
		return ;

	var queued_calls = wallboard.find('div.waiting_callers > div.panel-container').children('span.panel-data');
	queued_calls.html(data.queued_calls);
	wallboard.find('div.logged_in_members > div.panel-container').children('span.panel-data').html(data.logged_in_members);
	wallboard.find('div.available_members > div.panel-container').children('span.panel-data').html(data.available_members);

	var longest_hold_panel = wallboard.find('div.longest_hold > div.panel-container');
	var max_call_waiting = longest_hold_panel.children('span.panel-data');
	max_call_waiting.html(toHHMMSS(data.longest_hold_time));
	if(typeof queue_wallboard_intervals[data.queue] === 'undefined'){
		queue_wallboard_intervals[data.queue] = setInterval(function () {
			var current = parseInt(toSeconds(max_call_waiting.text()));
			var new_time = current + 1;
			var current_calls = parseInt(queued_calls.text());
			var sla_target = parseInt(longest_hold_panel.attr('sla_target'));
			if(sla_target > 0){
				var danger_sla = (+sla_target) * 2;
				if(new_time >= sla_target && new_time < danger_sla){
					longest_hold_panel.removeClass('w-bg-danger');
					longest_hold_panel.addClass('w-bg-warning');
				}else if(new_time >= danger_sla){
					longest_hold_panel.removeClass('w-bg-warning');
					longest_hold_panel.addClass('w-bg-danger');
				}
			}else if(new_time >= 20 && new_time < 30){
				longest_hold_panel.removeClass('w-bg-danger');
				longest_hold_panel.addClass('w-bg-warning');
			}else if(new_time >= 30){
				longest_hold_panel.removeClass('w-bg-warning');
				longest_hold_panel.addClass('w-bg-danger');
			}

			if(current_calls > 0){
				max_call_waiting.html(toHHMMSS(new_time));
			}else{
				clearInterval(queue_wallboard_intervals[data.queue]);
				max_call_waiting.html(toHHMMSS(0));
				longest_hold_panel.removeClass('w-bg-danger');
				longest_hold_panel.removeClass('w-bg-warning');
				queue_wallboard_intervals[data.queue] = undefined;
			}
		}, 1000)
	}
}
