$(function () {
	addModuleCallBack('layouts', function () {
		launchModuleCallBack('no_menu');
		var grid_panel = $('#widgets-container').find('.grid-stack-panel');

		grid_panel.gridstack({
			cellHeight: 80,
			verticalMargin: 10,
			handle: '.grid-stack-header'
		});

		grid_panel.on('added', function(event, items) {
			for (var i = 0; i < items.length; i++) {
				var item =  items[i];
				var el = $("#" + item.id);
				grid_stack_items_interactions(el);
			}
		});

		$("#add-widget").on('click', function () {
			var modal = create_modal(widget_modal_title, function () {
				//Nothing to do here
			});

			var dropdown = $("<select>");
			var none_option = $("<option>");
			var modal_body = modal.find(".modal-body");
			dropdown.addClass('form-control');
			none_option.attr('value',null);
			none_option.text(widget_modal_dropdown_none);
			none_option.appendTo(dropdown);
			$.each(widgets_list, function (i, data) {
				var option = $("<option>");
				option.attr('value', data.value);
				option.text(data.content);
				option.appendTo(dropdown);
			});

			modal_body.append(dropdown);

			var frm_content = $("<div>");
			frm_content.attr('id','widget-frm-content');
			modal_body.append(frm_content);
			layout_modal_dd_interaction(dropdown, frm_content, modal);
			modal.find('.modal-footer').remove();

			modal.modal();
		});

		$("#save-layout").on('click', function () {
			var lec = $("#layouts-editor-content");
			var data = {
				'action': 	lec.find('input[name="action"]').val(),
				'layout_id': lec.find('input[name="layout_id"]').val(),
				'name': '',
				'widgets': {}
			};

			$.each(lec.find('.grid-stack-item'), function () {
				var widget = $(this);
				data['widgets'][widget.attr('id')] = {
					'layout_widget_id': widget.attr('data-layout-widget'),
					'widget': widget.attr('data-widget'),
					'title': widget.find('span.title').text(),
					'pos_x': widget.attr('data-gs-x'),
					'pos_y': widget.attr('data-gs-y'),
					'width': widget.attr('data-gs-width'),
					'height': widget.attr('data-gs-height'),
					'items': widget.attr('data-selected-items'),
					'settings': {}
				};

				widget.find('input[name^="settings"]').each(function () {
					data['widgets'][widget.attr('id')]['settings'][$(this).data('param-id')] = $(this).val();
				});
			});

			var widgets_counter = Object.keys(data['widgets']).length;
			if(widgets_counter < 1){
				toastr.error(no_widgets_on_save, layout_error);
			}else{
				swal({
						title: layout_swal_title,
						text: layout_swal_input,
						confirmButtonText: layout_swal_ok,
						type: "input",
						showCancelButton: true,
						closeOnConfirm: false,
						confirmButtonColor: "#3091df",
						animation: "slide-from-top",
						inputPlaceholder: layout_swal_input,
						inputValue : lec.find('input[name="name"]').val()
					},
					function(inputValue){
						if (inputValue === false) return false;

						if (inputValue === "") {
							swal.showInputError(no_layout_name);
							return false
						}

						data['name'] = inputValue;
						virtual_submit(data);
						swal.close();
					});
			}

		});

		$.each(grid_panel.find('.grid-stack-item'),function () {
			grid_stack_items_interactions($(this));
		})
	});
});

function layout_modal_dd_interaction(select, container, modal) {
	select.on('change', function () {
		var value = $(this).val();
		if(value.length > 0){
			modal.modal('hide');
			virtual_submit({
				'action': $('input[name="wform_action"]').val(),
				'widget': value
			});
		}else{
			container.html('');
		}
	});
}

function grid_stack_items_interactions(el) {
	var close_btn = el.find('i.wclose');
	close_btn.on('click', function () {
		var item = $(this).closest("div.grid-stack-item");
		var gs = item.closest("div.grid-stack");
		var grid = gs.data("gridstack");
		grid.removeWidget(item);
	});

	var settings_btn = el.find('i.wsettings');
	settings_btn.on('click', function () {
		var item = $(this).closest("div.grid-stack-item");
		var widget = item.attr('data-widget');
		var data = {
			'action': $('input[name="wform_action"]').val(),
			'widget': widget,
			'layout_widget_id': item.attr('data-layout-widget'),
			'items': item.attr('data-selected-items'),
			'title': item.find('span.title').text(),
			'current_data': {
				'id': item.attr('id'),
				'pos-x': item.attr('data-gs-x'),
				'pos-y': item.attr('data-gs-y'),
				'width': item.attr('data-gs-width'),
				'height': item.attr('data-gs-height')
			}
		};

		item.find('input[name^="settings"]').each(function () {
			data[$(this).data('param-name')] = $(this).val();
		});

		virtual_submit(data);
	});
}