var app = new function(){
  this.first_load = function(){
    server_request('first_load');
  };

  this.aside_menu_interaction = function(){
    var left_menu = $('#aside-main-menu');

    left_menu.find('li > a').unbind('click');
    left_menu.find('li > a').on('click', function(){
      var action = $(this).attr('data-mod-menu');
      var btn = $("#right-menu-toggle");
      btn.hide();
      $('.current-active').removeClass('current-active');
      $(this).addClass('current-active');

      if(typeof action !== 'undefined'){
        btn.attr('data-action', action)
      }
    });
  };
  this.left_menu_toggle = function(){
    var btn = $("#toggle-app-menu");
    var sidebar_panel = $("#left-nav-sidebar");
    var backdrop = $("#navigation-backdrop");
    var modules_menu = $("#aside-nav-right");

    btn.unbind('click');
    btn.bind('click', function() {
      if(modules_menu.hasClass('show')){
	      modules_menu.removeClass('show');
	      backdrop.removeClass('show');
      }

      backdrop.removeClass('right');
      sidebar_panel.toggleClass('open');
      backdrop.toggleClass('show');
    });
  };
  this.right_menu_toggle = function(){
    var btn = $("#right-menu-toggle");
    var modules_menu = $("#aside-nav-right");
    var backdrop = $("#navigation-backdrop");

    btn.unbind('click');
    btn.on('click', function() {
      modules_menu.addClass('show');
      backdrop.addClass('show right');
      server_request($(this).attr('data-action'));
    });
  };
  this.backdrop_interaction = function () {
    var backdrop = $("#navigation-backdrop");
    var ww = $(window).width();
    var modules_menu = $("#aside-nav-right");
    var sidebar_panel = $("#left-nav-sidebar");

    backdrop.unbind('click');
    backdrop.bind('click', function(){
      modules_menu.removeClass('show');
      $(this).removeClass('show');
      sidebar_panel.removeClass('open');
    });
  };
  this.main_menu_interaction = function(){
    var aside_navigation = $("#aside-main-menu");
    aside_navigation.find('a[role="tab"]').on('click',function () {
        aside_navigation.find('div[role="tabpanel"].active').removeClass('active in')
    });
  };
  this.layouts_menu = function () {
      var layouts_menu = $("#layouts-menu");
      layouts_menu.unbind('click');
      layouts_menu.on('click', function () {
         var ac = $(this).attr('data-ac');
	      server_request(ac);
      });

      var ul = $("#user-layouts-dropdown");

	  ul.find('li.layouts').unbind('click');
      ul.find('li.layouts').on('click', function () {
	      ul.find('li.layouts').removeClass('active');
	      $(this).addClass('active');
      });

	  ul.find('li.layouts_action').unbind('click');
      ul.find('li.layouts_action').on('click', function () {
          var a = $(this).find('a');
          var active = ul.find('li.active');
          var type = a.attr('data-type');
          var ac = a.attr('data-ac');
          var selected_layout = active.find('a').attr('data-layout');

          if(type === 'new'){
            server_request(ac);
          }else{
            server_request(ac, selected_layout);
          }

	      layouts_menu.dropdown('toggle');
          return false;
      });
  }
};

app.first_load();

function custom_delegate(){
  app.aside_menu_interaction();
  app.right_menu_toggle();
  app.left_menu_toggle();
  app.backdrop_interaction();
  app.main_menu_interaction();
  app.layouts_menu();
}


function show_module_menu_btn(){
  $("#right-menu-toggle").show();
}

function hide_module_menu_btn(){
    $("#right-menu-toggle").hide();
}

function close_right_sidebar(){
  var backdrop = $("#navigation-backdrop");
  var ww = $(window).width();
  var modules_menu = $("#aside-nav-right");
  var sidebar_panel = $("#left-nav-sidebar");

  modules_menu.removeClass('show');
  backdrop.removeClass('show right');
  sidebar_panel.removeClass('open');
}

function toHHMMSS(s) {
	var sec_num = parseInt(s, 10);
	var hours = Math.floor(sec_num / 3600);
	var minutes = Math.floor((sec_num - (hours * 3600)) / 60);
	var seconds = sec_num - (hours * 3600) - (minutes * 60);

	if (hours   < 10) {hours   = "0"+hours;}
	if (minutes < 10) {minutes = "0"+minutes;}
	if (seconds < 10) {seconds = "0"+seconds;}
	if(parseInt(hours) > 0){
		return hours + ':' + minutes + ':'+ seconds;
    }else{
		return minutes + ':'+ seconds;
    }
}

function toSeconds(hms) {
	var a = hms.split(':');
	if(a.length === 2){
		return (+a[0]) * 60 + (+a[1]);
    }else if(a.length === 3){
		return (+a[0]) * 60 * 60 + (+a[1]) * 60 + (+a[2]);
    }

    return 0;

}
